//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <BCB.inc>
#include <Classes.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <CADImage.hpp>
#include <CADExport.hpp>
#ifdef CADExportVCL
	#include <CADtoDXF.hpp>
	#include <CADtoDWG.hpp>
	#include <CADtoHPGL.hpp>
	#include <CADtoPDF.hpp>
	#include <CADtoCGM.hpp>
	#include <CADtoSVG.hpp>
#endif
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TPanel *Panel2;
	TImage *sgPaintBox;
	TButton *btPicture1;
	TButton *btPicture2;
	TButton *btPicture3;
	TButton *btPicture4;
	TButton *btFullPicture;
	TButton *btSave;
	TSaveDialog *SaveDialog;
	void __fastcall btPicture1Click(TObject *Sender);
	void __fastcall btPicture2Click(TObject *Sender);
	void __fastcall btPicture3Click(TObject *Sender);
	void __fastcall btPicture4Click(TObject *Sender);
	void __fastcall btFullPictureClick(TObject *Sender);
	void __fastcall btSaveClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
//	void __fastcall FormCreate(TObject *Sender);
private:	// User declarations
	TsgCADImage *fDrawing;
public:		// User declarations
	void __fastcall Add2DVertex(TsgDXFLWPolyline *ALWPoly, const double X, const double Y, const double ABulge);
	void __fastcall Add3DVertex(TsgDXFPolyline *APoly, const double X, const double Y, const double Z);
	void __fastcall AddArc(TObject *Sender);
	void __fastcall AddCircle(TObject *Sender);
	void __fastcall AddDimension(TObject *Sender);
	void __fastcall AddDimensionStyle(TObject *Sender);
	void __fastcall AddDisplayViewport(TObject *Sender);
	void __fastcall AddEntToSection(TsgDXFGroup *Section, TsgDXFEntity *Entity);
	void __fastcall AddFaceByVertices(TsgDXFPolyline *APoly, const int N1, const int N2, const int N3, const int N4);
	void __fastcall AddHatch(TObject *Sender);
	void __fastcall AddImageEnt(TObject *Sender);
	void __fastcall AddInsert(TObject *Sender);
	void __fastcall AddLayer(TObject *Sender);
	void __fastcall AddLayout(TObject *Sender);
	void __fastcall AddLine(TObject *Sender);
	void __fastcall AddLineType(TObject *Sender);
	void __fastcall AddLWPolyline(TObject *Sender);
	void __fastcall AddModelViewport(TObject *Sender);
	void __fastcall AddMText(TObject *Sender);
	void __fastcall AddPolyline1(TObject *Sender);
	void __fastcall AddPolyline2(TObject *Sender);
	void __fastcall AddSolid(TObject *Sender);
	void __fastcall	AddSpline(TObject *Sender);
	void __fastcall AddStyle(TObject *Sender);
	void __fastcall AddText1(TObject *Sender);
	void __fastcall AddText2(TObject *Sender);
	bool __fastcall NewDrawing(TObject *Sender);
	bool __fastcall PlaceEntity(TsgDXFEntity *AEntity, const AnsiString ALayoutName);
	void __fastcall SetGraphic(TObject *Sender);

	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
